module Mobile
  module Entities
    class Message < Grape::Entity
      include ApplicationHelper
      include ApiHelper
      def self.message_expose(f)
        expose f do |u,opt|
          if u.is_a?(Hash) && u.key?(f)
            u[f]
          elsif u.is_a?(::Message)
            if u.respond_to?(f)
              if f == :created_on
                format_time( u.send(f))
              else
                u.send(f)
              end
            else
              case f
                when :course_project_name
                  if u.board.project_id == -1
                    u.course.name
                  else
                    u.project.name
                  end
                when :lasted_comment
                  time_from_now u.created_on
                when :praise_count
                  get_activity_praise_num(u)
                when :act_type
                  'Message'
                when :act_id
                  u.id
              end
            end
          end

        end
      end

      expose :user, using: Mobile::Entities::User do |c, opt|
        if c.is_a?(::Message)
          c.author
        end
      end
      message_expose :act_type
      message_expose :act_id
      message_expose :course_project_name
      message_expose :board_id
      message_expose :subject
      message_expose :content
      message_expose :replies_count
      message_expose :praise_count
      message_expose :created_on
      message_expose :locked
      message_expose :id
      message_expose :lasted_comment
      expose :message_children,using:Mobile::Entities::Message do |c,opt|
        if c.is_a? (::Message)
          c.children.reverse
        end
      end
      expose :has_praise , if: lambda { |instance, options| options[:user] } do |instance, options|
        has_praise = false
        current_user = options[:user]
        obj = PraiseTread.where("praise_tread_object_id=? and praise_tread_object_type=? and user_id=?",instance.id,instance.class.to_s,current_user.id)
        has_praise = obj.empty? ? false : true
        has_praise
      end
    end
  end
end